#include "mojeokno.h"
#include "ui_mojeokno.h"

MojeOkno::MojeOkno(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MojeOkno)
{
    ui->setupUi(this);
}

MojeOkno::~MojeOkno()
{
    delete ui;
}

QTableWidgetItem * v [8][8];

void MojeOkno::skoc(int x0, int y0, int n,
                    int x, int y)
{
    if (x >= 0 && x <= 7 &&
        y >= 0 && y <= 7 && n <= limit)
    {
        QTableWidgetItem * p = v [x][y];
        if (p == NULL)
        {
            QString s = QString::number (n);
            QString t = ('a'+x0) + QString::number (y0+1);
            if (n == 0) t = "zacatek";

            QColor c = QColor::fromHsv((n*20)%360, 200, 255);

            QString q = QString::number (n) + " : " + t + " -> " +
                QString ('a'+x) + QString::number (y+1);

            QTreeWidgetItem * node = new QTreeWidgetItem;
            node->setText(0, q);
            node->setTextColor (0, c);

            if (branch == NULL)
               ui->treeWidget->addTopLevelItem (node);
            else
               branch->addChild (node);

            QTreeWidgetItem * save = branch;
            branch = node;

            p = new QTableWidgetItem;
            p->setText (s);
            p->setToolTip (t);
            p->setBackgroundColor (c);
            p->setTextColor(QColor ("red"));
            ui->tableWidget->setItem(y, x, p);
            // assert (v[x][y] == NULL);
            v[x][y] = p;

            skoc (x, y, n+1, x+2, y+1);
            skoc (x, y, n+1, x-2, y+1);
            skoc (x, y, n+1, x+2, y-1);
            skoc (x, y, n+1, x-2, y-1);

            skoc (x, y, n+1, x+1, y+2);
            skoc (x, y, n+1, x-1, y+2);
            skoc (x, y, n+1, x+1, y-2);
            skoc (x, y, n+1, x-1, y-2);

            branch = save;
        }
    }
}

void MojeOkno::on_actionRun_triggered()
{
    ui->tableWidget->setColumnCount(8);
    ui->tableWidget->setRowCount(8);

    int h = ui->tableWidget->rowHeight (0);
    for (int i = 0; i <= 7; i++)
        ui->tableWidget->setColumnWidth (i, h);

    for (int i = 0; i <= 7; i++)
        for (int j = 0; j <= 7; j++)
            v[i][j] = NULL;

    QStringList list;
    for (int i = 0; i <= 7; i++)
        list << QString ('a'+i);
    ui->tableWidget->
            setHorizontalHeaderLabels(list);



    ui->tableWidget->clearContents ();
    ui->treeWidget->clear ();

    limit = ui->horizontalSlider->value();
    int x = ui->spinBoxX->value();
    int y = ui->spinBoxY->value();

    branch = NULL;
    skoc (0, 0, 0, x, y);
}
